#ifndef H_PPDEBUG
#define H_PPDEBUG

/**
 * @file Contains internal debugging features.
 *  Use only for debugging!
 */

#include "template/template.h"
#define D(var) { cout << #var << ": " << (var) << endl; }

// DO NOT TRY TO MAKE A MISTYPE!!!!
#define TPL_T template <class T>
#define TPL_ST template <class S, class T>

#define OSTREAM(X...) ostream& operator << (ostream &out, const X& temp)

TPL_ST OSTREAM(pair<S,T>) \
    { out << "(" << temp.fi << "," << temp.se << ")"; return out; } 

TPL_T OSTREAM(pair<T*, T*>) \
    { out << "[ "; for(T* q = temp.fi; q != temp.se; q++) out << *q << ", "; out << "]"; \
        return out; };


#define _OUT(X, Y...) X OSTREAM(Y) { \
        out << "[ "; FOREACH(it, temp) out << *it << ", "; out << "]"; \
        return out; };

_OUT(TPL_T, vector<T>);
_OUT(TPL_T, list<T>);
_OUT(TPL_T, set<T>);
_OUT(TPL_T, multiset<T>);

_OUT(TPL_ST, map<S,T>);
_OUT(TPL_ST, multimap<S,T>);
_OUT(TPL_ST, set<S,T>);


#endif
