#include "fenwick.h"
#include "gtest/gtest.h"
#include "template/template.h"

namespace interval_trees {
namespace fenwick {

TEST(FenwickSum, simpleQueries)
{
  FenwickSumTree<int> fenwick;
  fenwick.initialize(11);
  EXPECT_EQ(0, fenwick.get_prefix_sum(0));
  EXPECT_EQ(0, fenwick.get_prefix_sum(5));
  EXPECT_EQ(0, fenwick.get_prefix_sum(10));
  fenwick.increment(5, 5);
  EXPECT_EQ(0, fenwick.get_prefix_sum(0));
  EXPECT_EQ(0, fenwick.get_prefix_sum(4));
  EXPECT_EQ(5, fenwick.get_prefix_sum(5));
  EXPECT_EQ(5, fenwick.get_prefix_sum(10));
}

} // namespace fenwick
} // namespace interval_trees
