#include "full_binary_tree.h"
#include "gtest/gtest.h"
#include "debug/ppdebug.h"

namespace interval_trees {

TEST(FullBinary, badInitialization)
{
  EXPECT_THROW(FullBinaryTree<int> s; s.initialize(0),
                   std::invalid_argument);
}

TEST(FullBinary, goodInitialization)
{
  FullBinaryTree<int> s;
  s.initialize(16);
}


TEST(FullBinary, traversal) {
  FullBinaryTree<int> s;
  s.initialize(16);
  FullBinaryTree<int>::Traverser t = s.root();
  EXPECT_EQ(0u, t.range_left());
  EXPECT_EQ(16u, t.range_right());

  EXPECT_EQ(0u, t.left().range_left());
  EXPECT_EQ(8u, t.left().range_right());

  EXPECT_EQ(8u, t.right().range_left());
  EXPECT_EQ(16u, t.right().range_right());

}

}
