#include "simple_max.h"
#include "interval_trees/array/interval_array.h"
#include "gtest/gtest.h"
#include "template/template.h"
#include "utils/rand/rand.h"

#define TEST_ITERATIONS 200
#define QUERIES 10000

#define MAX 10000

namespace interval_trees{
namespace simple {

TEST(SimpleMax, CompareToArray)
{
  printf("going to test %d iterations with %d queries each "
         "on max %d values\n", TEST_ITERATIONS, QUERIES, MAX);
  Rand rand(20);
  FOR(cnt, TEST_ITERATIONS) {
    SimpleMaxTree<int> simple;
    IntervalMaxArray<int> array;

    int n = rand.rand(1, MAX + 1);
    simple.initialize(n);
    array.initialize(n);

    int k = rand.rand(1, 21);
    FOR(q, QUERIES) {
        if (rand.rand(0, 50) > 0) {
            int pos = rand.rand(0, n);
            int t = rand.rand(0, q*k+1);
            simple.set(pos, t);
            array.set(pos, pos+1, t);
        } else {
            int r = rand.rand(1, n);
            int l = rand.rand(0, r);
            EXPECT_EQ(array.get_max(l, r), simple.get_max(l, r));
        }
    }
  }
}

} // namespace simple
} // namespace interval_trees
