#include <stdio.h>
#include "extended_gcd.h"
#include "extended_gcd_loop.h"
#include "utils/benchmark/benchmark.h"
#include "gtest/gtest.h"

namespace math {
namespace gcd {

template<typename Algorithm>
void test_intervals(int l1, int r1, int l2, int r2) {
  for (int i = l1; i < r1; i++)
    for (int j = l2; j < r2; j++)
      Algorithm::extended_gcd_positive(i, j);
}

TEST(ExtendedGCD, benchmark) {
  AUTO_BENCHMARK(test_intervals<ExtendedGCD>(0, 1000, 0, 1000));
  AUTO_BENCHMARK(test_intervals<ExtendedGCDLoop>(0, 1000, 0, 1000));

  AUTO_BENCHMARK(test_intervals<ExtendedGCD>(
        1000000000, 1000010000, 1000000000, 1000010000));
  AUTO_BENCHMARK(test_intervals<ExtendedGCDLoop>(
        1000000000, 1000010000, 1000000000, 1000010000));
}

} // namespace gcd
} // namespace math
