#include <stdio.h>
#include "gcd.h"
#include "extended_gcd.h"
#include "extended_gcd_loop.h"
#include "utils/benchmark/benchmark.h"
#include "gtest/gtest.h"

namespace math {
namespace gcd {

void test_intervals(int l1, int r1, int l2, int r2) {
  for (int i = l1; i < r1; i++) {
    for (int j = l2; j < r2; j++) {
      EXPECT_EQ(ExtendedGCD::extended_gcd_positive(i, j),
          ExtendedGCDLoop::extended_gcd_positive(i, j));
      std::pair<int, int> tmp = ExtendedGCD::extended_gcd_positive(i , j);
      EXPECT_EQ(gcd(i, j), tmp.first * i + tmp.second * j);
    }
  }
}

TEST(ExtendedGCD, test) {
  test_intervals(0, 1000, 0, 1000);

  test_intervals(
        1000000000, 1000010000, 1000000000, 1000010000);
}

} // namespace gcd
} // namespace math
