#include "gtest/gtest.h"
#include "modular_inverse_precomputed.h"
#include "modular_inverse_fermat.h"
#include "modular_inverse_gcd.h"
#include "utils/benchmark/benchmark.h"


namespace math {
namespace modular_inverse {

TEST(ModularInverse, compareFermatGcd) {
  unsigned int primes[] = {2, 3, 5, 7, 11, 13,
    4987, 43991, 77477, 195413, 293173,
    435371, 568999, 888061,
    0};
  for (int i = 0; primes[i] != 0; i++) {
    unsigned int p = primes[i];
    for (unsigned int j = 0; j < p; j++) {
      ASSERT_TRUE((int)ModularInverseFermat::getInverse(j, p) ==
                    ModularInverseGcd::getInverse((int)j, (int)p));
    }
  }
}


} // namespace modular_inverse
} // namespace math
