#include "gtest/gtest.h"
#include "utils/benchmark/benchmark.h"
#include "utils/macros/unused.h"
#include "segmented_sieve.h"

namespace math {
namespace prime_sieve {

class Callback: public SieveCallback {
 public:
   virtual void foundPrime(long long int UNUSED(x)) {
   }
};

#define Mi 1000000ll
#define Gi (1000 * Mi)
TEST(BenchmarkSegmentedSieve, sieve)
{
  Callback c;
  BENCHMARK(100, SegmentedSieve::findPrimes(1 * Mi, &c));
  BENCHMARK(10, SegmentedSieve::findPrimes(10 * Mi, &c));
  BENCHMARK(1, SegmentedSieve::findPrimes(100 * Mi, &c));
  BENCHMARK(1, SegmentedSieve::findPrimes(Gi, &c));
  BENCHMARK(1, SegmentedSieve::findPrimes(10 * Gi, &c));
  BENCHMARK(1, SegmentedSieve::findPrimes(100 * Gi, &c));
}

} // namespace prime_sieve
} // namespace math
