#ifndef H_PRIMES_TEST_DATA
#define H_PRIMES_TEST_DATA
/**
 * This file holds some explicit counts of primes in specific ranges.
 *
 * It is used only for unittesting implementations.
 */
namespace testdata {
  /**
   * Numer of twin primes (p and p+2 are both primes)
   * up to specified number.
   *
   * Data based on http://www.trnicely.net/twins/twins2.html
   */
  long long int prime_twins_count[][2] = {
    {3, 0},
    {4, 0},
    {5, 0}, // range is not inclusive!
    {6, 1},
    {10, 2},
    {100, 8},
    {1000, 35},
    {10000, 205},
    {100000, 1224},
    {1000000, 8169},
    {10000000, 58980},
    {100000000, 440312},
    {1000000000, 3424506},
    {0, 0}
  };

  /**
   * Number of primes in range [2, x)
   *
   * Data manually generated and generated with Mathematica 5
   */
  long long int prime_count_small[][2] = {
    {3, 1},
    {4, 2},
    {5, 2},
    {6, 3},
    {7, 3},
    {8, 4},
    {20, 8},
    {155, 36},
    {3331, 469},
    {12345, 1474},
    {0, 0}
  };

  /**
   * Number of primes in range [0, x)
   *
   * Data based on direct computation with Mathematica 5
   */
  long long int prime_count_big[][2] = {
    {123456, 11601},
    {1234567, 95360},
    {12345678, 809227},
    {123456789, 7027260},
    {1234567890, 62106578},
   // {12345678901ll, 556442057},
    // and something that even result count won't fit into int 
   // {120000000000ll, 4904759399ll},
    {0, 0}
  };

}
#endif
