#include "gtest/gtest.h"
#include "lcp_naive.h"
#include "debug/ppdebug.h"
#include <cstdio>

TEST(NaiveSuffixArray, buildSuffixesSimple) {
  const unsigned int N = 11;
  char str[N + 1] = "abracadabra";
  int sa[N] = {10, 7, 0, 3, 5, 8, 1, 4, 6, 9, 2};

  vector<int> result;
  strings::suffix_array::LCPNaive::getHeightArray(
      str, str + N, sa, sa + N, &result);

  int expected[N] = {-47, 1, 4, 1, 1, 0, 3, 0, 0, 0, 2};
  ASSERT_EQ(N, result.size());
  for (unsigned int i = 1; i < N; i++) {
    ASSERT_EQ(expected[i], result[i]);
  }

}
