#include "gtest/gtest.h"
#include "naive.h"
#include "debug/ppdebug.h"
#include <cstdio>

TEST(NaiveSuffixArray, buildSuffixesSimple) {
  const unsigned int N = 11;
  char str[N + 1] = "abracadabra";
  vector<int> result;
  strings::suffix_array::NaiveSuffixArray::buildSuffixArray(str, str + N, &result);

  int expected[N] = {10, 7, 0, 3, 5, 8, 1, 4, 6, 9, 2};
  ASSERT_EQ(N, result.size());
  for (unsigned int i = 0; i < N; i++) {
    ASSERT_EQ(expected[i], result[i]);
  }

}
