#include "gtest/gtest.h"
#include "utils/benchmark/benchmark.h"

#include "sequence_loader.h"
#include <map>

namespace strings {
namespace utils {

const char* FILENAME_CHROMO_Y = "../testdata/genome/chrY.fa";

TEST(SequenceLoader, loadingBigFiles) {
  std::map<unsigned char, unsigned char> mapa;
  mapa['C'] = 1;
  mapa['G'] = 2;
  mapa['A'] = 3;
  mapa['T'] = 4;
  mapa['c'] = 5;
  mapa['g'] = 6;
  mapa['a'] = 7;
  mapa['t'] = 8;
  mapa['N'] = 0;

  std::vector<unsigned char> seq;

  BENCHMARK(1,
    seq = SequenceLoader::loadSequence(FILENAME_CHROMO_Y, mapa));

  printf("sequence size: %lu\n", (unsigned long) seq.size());
}

} // namespace utils
} // namespace strings
