#include "gtest/gtest.h"

#include "sequence_loader.h"
#include <map>

namespace strings {
namespace utils {

TEST(SequenceLoader, nonexistent) {
  std::map<unsigned char, unsigned char> mapa;
  ASSERT_THROW(SequenceLoader::loadSequence("junk", mapa), std::runtime_error);
}

TEST(SequenceLoader, filtering) {
  std::map<unsigned char, unsigned char> mapa;
  mapa['a'] = 1;
  ASSERT_EQ(2u, 
      SequenceLoader::loadSequence("loader_test.dat", mapa).size());

  mapa['b'] = 2;
  ASSERT_EQ(4u, 
      SequenceLoader::loadSequence("loader_test.dat", mapa).size());
}

TEST(SequenceLoader, whiteSpaces) {
  std::map<unsigned char, unsigned char> mapa;
  for (int i = 0; i < 256; i++) {
    mapa[(unsigned char) i] = (unsigned char) i;
  }
  ASSERT_EQ(76u, 
      SequenceLoader::loadSequence("loader_test_whitespace.dat", mapa).size());
}


} // namespace utils
} // namespace strings
