#ifndef H_UTILS_MACROS_ARRAY_SIZE
#define H_UTILS_MACROS_ARRAY_SIZE
/**
 * This file contains macro which can determine size of an array
 *
 * Macro is taken from chrome's basictypes.h.
 * ARRAY_SIZE relies on template matching failure
 * if the argument is not an array.
 */
template <typename T, unsigned int N>
char (&ArraySizeHelper(T (&array)[N]))[N];

template <typename T, unsigned int N>
char (&ArraySizeHelper(const T (&array)[N]))[N];

/**
 * Macro which can determine size of the array.
 *
 * Basic usage:
 * int a[5];
 * cout >> ARRAY_SIZE(a); // 5
 *
 * int funct(int b*) {
 *   cout >> ARRAY_SIZE(b); // compilation error
 */
#define ARRAY_SIZE(array) (sizeof(ArraySizeHelper(array)))

#endif
