#include <cassert>
#include "gtest/gtest.h"
#include "preconditions.h"
#include "utils/benchmark/benchmark.h"
#include "utils/si_units/si_units.h"

TEST(Preconditions, benchmarkAgainstAssert) {
  AUTO_BENCHMARK({ volatile int e = 1; Preconditions::check(e); });
  AUTO_BENCHMARK({ volatile int e = 1; assert(e); });
}

TEST(Preconditions, benchmarkExceptions) {
  AUTO_BENCHMARK({ volatile int e = 1; Preconditions::check(e); });
  AUTO_BENCHMARK(
      try {
        volatile int e = 0;
        Preconditions::check(e);
      } catch (std::exception &e) {

      });
}


