#include "gtest/gtest.h"
#include "preconditions.h"

TEST(Preconditions, check) {
  EXPECT_NO_THROW(Preconditions::check(1==1));

  bool a=1;
  EXPECT_NO_THROW(Preconditions::check(a, "should be true"));

  EXPECT_THROW(Preconditions::check(1==2),
               std::invalid_argument);

  EXPECT_THROW(Preconditions::check(1>2, "Message"),
               std::invalid_argument);
}

TEST(Preconditions, checkRange) {
  EXPECT_NO_THROW(Preconditions::checkRange(0, 10));

  EXPECT_NO_THROW(Preconditions::checkRange(9, 10));

  EXPECT_THROW(Preconditions::checkRange(-1, 10),
               std::invalid_argument);

  EXPECT_THROW(Preconditions::checkRange(10, 10),
               std::invalid_argument);
}

TEST(Preconditions, checkRange2) {
  EXPECT_NO_THROW(Preconditions::checkRange(0, -5, 10));

  EXPECT_NO_THROW(Preconditions::checkRange(9, 8, 10));

  EXPECT_NO_THROW(Preconditions::checkRange(-2, -3, -1));

  EXPECT_THROW(Preconditions::checkRange(-1, -3, -1),
               std::invalid_argument);

  EXPECT_THROW(Preconditions::checkRange(5, 10, 0),
               std::invalid_argument);

  EXPECT_THROW(Preconditions::checkRange(10, 10, 10),
               std::invalid_argument);
}

