#include "gtest/gtest.h"
#include "utils/benchmark/benchmark.h"
#include "utils/si_units/si_units.h"

const int N = 10000;
char data[N][N];

void iterateij(int N, int M) {
  for (int i = 0; i < N; i++)
    for (int j = 0; j < M; j++)
      data[i][j] = i + j;
}

void iterateji(int N, int M) {
  for (int i = 0; i < N; i++)
    for (int j = 0; j < M; j++)
      data[j][i] = i + j;
}

TEST(CacheMiss, benchmark) {
  BENCHMARK(10, iterateij(10000, 10000));
  BENCHMARK(10, iterateji(10000, 10000));

  BENCHMARK(1000, iterateij(100, 10000));
  BENCHMARK(1000, iterateji(100, 10000));


  BENCHMARK(1000, iterateij(10000, 100));
  BENCHMARK(1000, iterateji(10000, 100));


  BENCHMARK(100000, iterateij(1, 10000));
  BENCHMARK(100000, iterateji(1, 10000));


  BENCHMARK(100000, iterateij(10000, 1));
  BENCHMARK(100000, iterateji(10000, 1));


  BENCHMARK(100000, iterateij(100, 100));
  BENCHMARK(100000, iterateji(100, 100));
}

