#include "gtest/gtest.h"
#include "utils/rand/rand.h"
#include <stdio.h>

TEST(SignedOverflow, multiply) {
  Rand r(47);
  const int ITER = 1000;

  printf("Multiplication sizes:\n");
  printf("char:  %d\n", (int) sizeof ((char)1 * (char) 1));
  printf("short: %d\n", (int) sizeof ((short)1 * (short) 1));
  printf("int:   %d\n", (int) sizeof ((int)1 * (int) 1));
  printf("ll:    %d\n", (int)sizeof ((long long)1 * (long long) 1));

  for (int i = 0; i < ITER; i++) {
    unsigned short a = r.rand(0, std::numeric_limits<unsigned short>::max());
    unsigned short b = r.rand(0, std::numeric_limits<unsigned short>::max());

    EXPECT_TRUE( (unsigned short) (a * b) == 
        (unsigned short) ((signed short) a * (signed short) b));
    // WARNING: BEWARE THAT THIS IS NOT THE SAME AS 
    // EXPECT_TRUE( (a * b) == 
    //    (unsigned short) ((signed short) a * (signed short) b));
    // The reason is that short*short => int
  }

}
